/*

     Program : demo
     Author  : Copyright (C) 1991, I.L.A. Inc. All Rights reserved.

     Switches: /m/n/w

  Before we start I apologies for any mistake or spelling errors
  that may be in the documentation part.
  My mother tounge is not english.

*/


#include "inkey.ch"
#include "setcurs.ch"
#include "zhelp.ch"

static ZCONTROL:={}
static getlist:={}

PROCEDURE main()

LOCAL T:=5,LM:=5
LOCAL VAR1:=SPACE(5)
LOCAL VAR2:=SPACE(5)
LOCAL VAR3:=SPACE(5)
LOCAL VAR4:=SPACE(5)
LOCAL VAR5:=SPACE(5)
LOCAL VAR6:=SPACE(5)
LOCAL VAR7:=SPACE(5)

ZINIT()

if ismouse()
   mouse(.t.)
   m_reset()
end

m_csroff()
cls()
box(1,1,maxrow()-1,maxcol()-1)
m_csron()
@ maxrow()-4,3 say " Press F1 to get help in any var. F12 for general help."
@ maxrow()-3,3 say " Press Alt-H for help when in help window."

@ ++T,LM SAY "VAR1 :" GET VAR1
@ ++T,LM SAY "VAR2 :" GET VAR2
@ ++T,LM SAY "VAR3 :" GET VAR3
@ ++T,LM SAY "VAR4 :" GET VAR4
@ ++T,LM SAY "VAR5 :" GET VAR5
@ ++T,LM SAY "VAR6 :" GET VAR6
@ ++T,LM SAY "VAR7 :" GET VAR7
@ t,lm+ 15 say "<- try F1 here."

READ

return



// init program parameters and help system 
***********************************************************************
PROC zINIT()
***********************************************************************
LOCAL HELPBLK:={|a,b,c,d|HELP(PROCNAME(2),PROCLINE(2),READVAR(),d)}
LOCAL HELP2BLK:={||HELP(PROCNAME(2))}
LOCAL MAXLPT:=2
LOCAL MY_HELP_DBF:="ZHELP",MY_AREA:=15,my_helpcol:=48,my_hhelpcol:=32
ZCONTROL:=ARRAY(ZDATASIZE)
AFILL(ZCONTROL,"")
/*
   The help key is generate from the parameters passed by the help block
   The line number is ignored.
   The second block is use for general help the help key is taken from
   the procedure name passed followed by '*'
*/

SET CONFIRM ON
SET SCOREBOARD OFF
SET BELL OFF
SET STATUS OFF
SET SAFETY OFF
SET DEVICE TO SCREEN
SET PRINT OFF

m_frame("͸Գ ")

Z_DATA(Z_MAXLPT,MAXLPT) // tell the system how many printer ports you have
                        // all printer should have LPT# assign to them

setdevices()    // set output devices for the program
                // MAXLPT must be set before calling this func.

/*

 You can set any key for your help activation but do not forget
 to tell z_data the key value as below.

*/ 

Z_DATA(PROCVARHELPKEY,K_F1)     // for sensitive help any var at wait state
SETKEY(K_F1,HELPBLK)

Z_DATA(PROCHELPKEY,K_F12)       // for general help (by procedures)
SETKEY(K_F12,HELP2BLK)


z_data(COLORHELPWINDOW,my_helpcol)      // help window color
                                        // You can change it any time.

z_data(COLORHELPONHELP,my_hhelpcol)     // help on help color
                                        // used with the Alt-H


z_data(HELPFILENAME,my_help_dbf)    /* name of zHelp dbf/dbt/ntx file.

must have the following format

Structure for database: ZHELP.DBF
Number of data records:      1
Date of last update   : 07/11/91

Field  Field Name  Type       Width    Dec
    1  HELP_KEY    Character     30
    2  HELP_TEXT   Memo          10
    3  TITLE       Character     75
    4  TOP         Numeric        3
    5  LEFT        Numeric        3
    6  BOTTOM      Numeric        3
    7  RIGHT       Numeric        3
    8  TEXT_WIDTH  Numeric        3
    9  FRAME_COL   Numeric        3
   10  TITLE_COL   Numeric        3
   11  TEXT_COL    Numeric        3
   12  TASK        Character     12     

    --  Total  --               152

*/

z_data(HELPFILEAREA,my_area)
        // Any valid area number is ok. zHELP will save and restore
        // areas when moving to/from help file.
        // If you select a 0 (zero) as area number then zHELP
        // will select the available area to load the help file
        // and close it on exit. (0 is not recomended althogh no problem
        // reported when using 0 as workarea.)

setcols()       // Set colors

RETURN


function CreateHelp(p,l,v,a)
/*
        The main help procedure look automaticaly for the help key
        in the help file if the key is not found then a call for
        this procedure is been made expecting True or False value
        to create new help subject.

        The help parameters are passing here from the main help procedure
        To allow you control on when to add help window.
*/

local nTcol:=48,cTscr:='',nTop:=1,nLeft:=20,nBottom:=8,nRight:=60,ntTop:=0
local x:=0
SAVECOL()
SETCOLOR(ATTRTOA(nTcol))
    M_CSROFF()
    cTscr:=savevideo()
    M_CSRON()
    settitle("")
    box(nTop,nLeft,nBottom,nRight,M_FRAME(),nTcol)
    ntTop:=nTop
    print(++ntTop,nLeft+2," No help existing here.",nTcol)
    print(++ntTop,nLeft+2," Create New Help Window here? ",nTcol)
    @ nBottom-2,nLeft+2 prompt "   Yes   "
    @ nBottom-2,nLeft+14 prompt "   No    "
    menu to x
    m_csroff()
    RESTVIDEO(cTscr)
    m_csron()
RESTCOL()
RETURN(IIF(X=1,.T.,.F.))

FUNCTION SETCOLS
LOCAL COLORSTR:='',MN:=0
LOCAL NSTD:=0,NENH:=0,NUNS:=0
mn:=montype()
if (mn=1 .or. mn=11.or.mn=7)
   colorstr:="W/N,N/W,,W/N"
   setcolor(colorstr)
ELSEIF (MN=4.OR. MN=12)
   PALETTE(4,8)
   colorstr:="W+/B,W+/R,B/N,N/N,B/W"
   SETCOLOR(colorstr)
ELSE
   colorstr:="W+/B,W+/R,B/N,N/N,B/W"
   SETCOLOR(colorstr)
endif
   nStd := atoattr( strextract( ColorStr, ",", 1))
   nEnh := atoattr( strextract( ColorStr, ",", 2))
   nUns := atoattr( strextract( ColorStr, ",", 4))
   standard(nstd)
   enhanced(nenh)
   unselected(nuns)
   savecol()
RETURN(NIL)

FUNCTION Z_DATA(Index,Value)
LOCAL ret_val := NIL
   IF( Index == NIL .AND. Value == NIL )
      return ( ZCONTROL )
   ENDIF
   IF( Index < 1 .or. Index > ZDATASIZE )
      return( -1 )
   ENDIF
   IF ( Value == NIL )
      ret_val := ZCONTROL[Index]
   ELSE
      ret_val := ZCONTROL[Index]
      ZCONTROL[Index] := Value
   ENDIF
return ret_val


FUNCTION ED_HELP()

/*
   This function control the edit mode in the help window.
   return .t. to allow editing.
*/

RETURN(.T.)

